/********************************************
 * Teora de autmatas y lenguajes formales *
 * Alumno: Nicols Kovac Neumann            *
 * Mail: alu3011@csi.ull.es                 *
 *                                          *
 * Programa de que intentara hacer uso de la*
 * mayoria de las cosas explicadas en clase *
 ********************************************/

// Recomiendo abrir este codigo con Emacs o XEmacs :)

// Este programa incluye, entre otras cosas, ejemplos de:
// 1) Flujos de entrada/salida
// 2) Clases, sus partes y su manejo
// 3) Funciones amigas
// 4) Sobrecarga de operadores
// 5) Creacion y destruccion de vectores dinamicos
// 6) Sentencia "switch"
// 7) Bucles while y for
// 8) Manipulacion de ficheros (lectura y escritura)
// 9) Uso de la sentencia "new"
// 10) Ambito de las variables

#include <iostream>
#include <fstream>
#include <string>
 
using namespace std;

 // Clase complejo
 class complejo {
   private:                                                                                     // En este caso private: se podra omitir
       float real, imaginario;                                                                  // Partes real e imaginaria de un complejo
   public:
       inline complejo() { };                                                                   // Constructor
       inline ~complejo() { };                                                                  // Destructor
       complejo AsignarValor(float a, float b);
       float DevolverValor(int tipo);
       complejo Intercambiar(complejo &a);                                                      // Funcion para intercambiar la parte real 
                                                                                                // por la imaginaria y viceversa   
       friend complejo operator+(const complejo &com1, const complejo &com2);                   // Ejemplo de sobrecarga del +
       friend complejo operator*(const complejo &com1, const complejo &com2);                   // Ejemplo de sobrecarga del *
       friend void imprimir_complejo(complejo n_com);                                           // Ejemplo de funcin amiga
 };
 
 // Implementacion de los metodos de la clase

 complejo complejo::AsignarValor(float a, float b) {
      real = a;
      imaginario = b;
 }

 float complejo::DevolverValor(int tipo) {
   switch(tipo) {
   case 0 : { return real;         
	      break; }
   case 1 : { return imaginario; 
              break; }
   default: return 0.0;  

   // Nota: En este caso no es imprescindible usar los break, debido a que al encontrar un return, la funcion deja de ejecutar el resto del codigo y devuelve el valor especificado en el return; los he incluido por mantener la sintaxis correcta de stos  
   }
 }

 complejo complejo::Intercambiar(complejo &a) {
          float aux;
          aux = a.real;
          a.real = a.imaginario;
          a.imaginario = aux;
          return a;
 }
 
 // Sobrecarga del operador +

 complejo operator+(const complejo &com1, const complejo &com2) {
          complejo resultado;
          resultado.real = com1.real + com2.real;
          resultado.imaginario = com1.imaginario + com2.imaginario;
          return resultado;
 }
 
 // Sobrecarga del operador *

 complejo operator*(const complejo &com1, const complejo &com2) {
   complejo resultado;
   resultado.real = (com1.real * com2.real) - (com1.imaginario * com2.imaginario);
   resultado.imaginario = (com1.imaginario * com2.real) + (com1.real * com2.imaginario);
   return resultado;
 }

 // Fin de la implementacion de los metodos de la clase
 // *************************************************** 

 const int maximo = 55;
 void fatal_error(char mensaje [maximo]) {
      cerr << "ERROR EN EL PROGRAMA: ";
      for (int r = 0; r < maximo; r++)
	   cerr << mensaje[r];
      cout << endl;
      cout << "Terminando la aplicacion" << endl;
      exit(1);
 } 

 void imprimir_complejo(complejo n_com) {
   cout << n_com.real << " + " << n_com.imaginario << "i" << endl;
   return;
 }

 // La siguiente funcin es para borrar la pantalla, de todos modos por lo visto en las prcticas ms vale no usarlo :)
 
 void BorraPantalla() {
      system("clear");
      return;
 }
 
 int main() {
     BorraPantalla();
     int num_elementos_vec;                                                       // Variable de elementos del vector
     cout << "Cuantos elementos quieres que tenga el vector?" << endl;
     cin >> num_elementos_vec;
     
     complejo *vec = new complejo [num_elementos_vec];                            // Definimos el vector
     if (!vec)
        fatal_error("No se pudo crear el vector por insuficiencia de memoria");
     
     for (int i = 0; i < num_elementos_vec; i++) {
          BorraPantalla();
          float preal, pimaginaria;                                               // Valores de la parte real e imaginaria
          cout << "Introduce el numero complejo numero " << i << ", por ejemplo para poner '2 + 3i', habria que poner '2 3'" << endl;
          cin >> preal >> pimaginaria;
          vec[i].AsignarValor(preal, pimaginaria); 
     }
     
     cout << "El vector ha sido llenado correctamente" << endl;
     
     // A continuacion vamos a sumar dos complejos (sobrecarga de operadores)
     int k;
     int j = k = num_elementos_vec + 1;                                         // Variables de dos posiciones en el vector

     // Comprobamos si las posiciones que nos dieron estan fuera del rango de nuestro vector

     while ((j >= num_elementos_vec) || (k >= num_elementos_vec)) {
           cout << "Introduce 2 posiciones del vector para sumar 2 numeros complejos" << endl;
           cin >> j >> k;
     }
     

     // Guardamos dos numeros complejos que corresponden con la posicion j, k del vector,
     // uno tercero para la suma de los dos numeros complejos, y uno cuarto para su multiplicacion
     complejo com1, com2, com3, com4;
     com1 = vec[j];
     com2 = vec[k];
     com3 = com1 + com2;
     com4 = com1 * com2;

     
     cout << "El primer complejo es: ";
     imprimir_complejo(com1);
     cout << "El segundo complejo es: ";
     imprimir_complejo(com2);
     
     cout << endl;
     cout << "El valor de la suma es: ";
     imprimir_complejo(com3);
     cout << "El valor de la multiplicacion es: ";
     imprimir_complejo(com4);

     cout << endl;
     complejo swap1, swap2;
     swap1.Intercambiar(com3);
     swap2.Intercambiar(com4);
     cout << "El resultado de la suma intercambiado es: ";
     imprimir_complejo(com3);
     cout << "El resultado de la multiplicacion intercambiado es: ";
     imprimir_complejo(com4);

     cout << endl;
     cout << endl;
     cout << "Por ultimo imprimimos cada uno de los elementos de nuestro vector en el archivo 'vector.dat', y despues lo destruiremos" << endl;

     ofstream fich("vector.dat");
     for (int l = 0; l < num_elementos_vec; l++) {
	  fich << vec[l].DevolverValor(0) << " + " << vec[l].DevolverValor(1) << "i" << endl;
     }
     fich.close();                                                // Es recomendable cerrar los archivos una vez terminamos de usarlos
     
     delete [] vec;

     cout << "El vector ha sido destruido" << endl;
     cout << endl;
     cout << "Ahora mostramos por pantalla el contenido del fichero que acabamos de crear" << endl;

     ifstream fich_ent("vector.dat");
     while (!fich_ent.eof()) {                                    // Bucle equivalente al 'while not eof(fich_ent)' de pascal
       string auxiliar;
       getline(fich_ent, auxiliar, '\n');
       cout << auxiliar << endl;
       // Nota: El ambito de las variables en un bucle son el mismo bucle, o sea, cuando salgamos del bucle, la variable se "destruye" 
     }

     fich_ent.close();

     cout << "Fin de la aplicacion" << endl;

     return 0;
 }
